; Program pro vypocet faktorialu
; Copyright (C) Michal Turek 2005 (tvrtek 16:15)

; 0 ... 1
; 1 ... 1
; 2 ... 2
; 3 ... 6
; 4 ... 24
; 5 ... 120
; 6 ... preteceni :(

; Definice cisla pro ktery se hleda faktorial
.equ NUM = 4

; inicializace zsobnku (SP <- 0x400)
.include "m169def.inc"
ldi r16, 0x00
out SPL, r16
ldi r16, 0x04
out SPH, r16

; Voln faktorilu
start:
	ldi r20, NUM
	push r20
	call Faktorial
	pop r20

end: jmp end


; Faktoril
Faktorial:
	; entry code (prologue)
	push r28
	push r29
	in r28, SPL	; naten adresy vrcholu zsobnku do Y
			; (Rd <- port[SPL])
	in r29, SPH

	; body
	ldd r16, Y+5	; parametr a (Rd <- data[Y+q])

	; if(n==1) return 1
	cpi r16, 2	; porovna r16 s dvojkou
	brlo return_1	; pokud je mensi, preskoci kod

	; else return n*Faktorial(n-1);
	mov r17, r16	; zaloha n
	dec r16		; n-=1

	push r17
	push r16	; Faktorial(n-1)
	call Faktorial
	pop r16
	pop r17

	mul r16, r17	; r0 = n*Faktorial(n-1);
	mov r16, r0	; r16 = r0
	jmp return


return_1:
	ldi r16, 1
;	jmp return

return:
	; exit code (epilogue)
	mov r26, r28	; X = Y
	mov r27, r29

	ldd r30, Y+4	; nvratov adresa (R30 <- data[Y+q])
	ldd r31, Y+3

	adiw r26, 5	; X += 5, R(d+1):Rd <- R(d+1):Rd + K
	pop r29
	pop r28
	out SPL, r26	; uma?e v?echna data vlo?en na zsobnk
			; (port[P] <- Rr)
	out SPH, r27
	push r16	; push the return value on the stack
	ijmp		; PC <- Z (Z = r30, r31)

