; Zobrazi 35
; Copyright (C) Michal Turek 2005 (tvrtek 16:15)

.include "m169def.inc"
.org 0x000

	ldi r16, 0x00
	out SPL, r16
	ldi r16, 0x04
	out SPH, r16

	call init_disp
	call clear_disp
;	call show_6
;	call show_35

end:
	jmp end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Inicializuje display
init_disp:
	ldi r16, 0xB7
	sts LCDCRB, r16
	ldi r16, 0x10
	sts LCDFRR, r16
	ldi r16, 0x0F
	sts LCDCCR, r16
	ldi r16, 0x80
	sts LCDCRA, r16
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Vymaze display
clear_disp:
	push r16
	clr r16
	sts LCDDR0   , r16	; data[k] <- Rr
	sts LCDDR0+5 , r16
	sts LCDDR0+10, r16
	sts LCDDR0+15, r16

	sts LCDDR1   , r16
	sts LCDDR1+5 , r16
	sts LCDDR1+10, r16
	sts LCDDR1+15, r16

	sts LCDDR2   , r16
	sts LCDDR2+5 , r16
	sts LCDDR2+10, r16
	sts LCDDR2+15, r16
	pop r16
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Zobrazi 35

show_35:
	push r16
	ldi r16, 0x01
	ori r16, 0x10
	sts LCDDR0,    r16
	ldi r16, 0x01
	ori r16, 0x40
	sts LCDDR0+5,  r16
	ldi r16, 0x0B
	ori r16, 0xB0
	sts LCDDR0+10, r16
	ldi r16, 0x01
	ori r16, 0x10
	sts LCDDR0+15, r16

	pop r16
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Zobrazi sestku
show_6:
	push r16
	ldi r16, 0x01
	sts LCDDR0,    r16
	ldi r16, 0x04
	sts LCDDR0+5,  r16
	ldi r16, 0x0F
	sts LCDDR0+10, r16
	ldi r16, 0x01
	sts LCDDR0+15, r16
	pop r16
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Zobrazi znak na display
; v r16 je znak
; v r17 je display
; nic se nevrace
; adresa = znaky + 4*ASCII - 42
show_char:
	push r0
	push r1
	push r16
	push r18
	push r30
	push r31

	ldi r30, low(znaky<<1)	; inicializace ukazatelu do pameti programu
	ldi r31, high(znaky<<1)

	ldi r18, 4
	mul r16, r18		; 4*ascii (vysledek v r1:r0)

	add r30, r0		
	adc r31, r1		; znaky + 4*ascii
	sbiw r30, 42		; adresa -= 42
				; v r31:r30 je adresa znaku

disp_nula:
	cpi r17, 0
	brne disp_jedna
	
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR0   , r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR0+ 5, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR0+10, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR0+15, r0	; hodi to na display

	jmp return

disp_jedna:
	; swapuje se dolni a horni ctverice bitu
	cpi r17, 1
	brne disp_dva

	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR0   , r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR0+ 5, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR0+10, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR0+15, r0	; hodi to na display

	jmp return


disp_dva:
	cpi r17, 2
	brne disp_tri

	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR1   , r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR1+ 5, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR1+10, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR1+15, r0	; hodi to na display

	jmp return

disp_tri:
	cpi r17, 3
	brne disp_ctyri

	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR1   , r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR1+ 5, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR1+10, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR1+15, r0	; hodi to na display

	jmp return

disp_ctyri:
	cpi r17, 4
	brne disp_pet

	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR2   , r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR2+ 5, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR2+10, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	sts LCDDR2+15, r0	; hodi to na display

	jmp return

disp_pet:
	cpi r17, 5
	brne return

	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR2   , r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR2+ 5, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR2+10, r0	; hodi to na display

	adiw r30, 1		; adresa += 1
	lpm			; do r0 nakopiruje znak, kterej se bude zobrazovat
	swap r0
	sts LCDDR2+15, r0	; hodi to na display

	jmp return

return:
	pop r31
	pop r30
	pop r18
	pop r18
	pop r1
	pop r0

	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Tabulka znaku

znaky:
.db 0b00001000, 0b00001010, 0b00001010, 0b00001110 ; *, 42
.db 0b00000000, 0b00001000, 0b00001010, 0b00000010 ; +, 43
.db 0b00000000, 0b00000000, 0b00000000, 0b00000010 ; ,, 44 
.db 0b00000000, 0b00000000, 0b00001010, 0b00000000 ; -, 45
.db 0b00000000, 0b00000000, 0b00000000, 0b00000001 ; ., 46
.db 0b00001000, 0b00000000, 0b00000000, 0b00000100 ; /, 47

.db 0b00001001, 0b00000101, 0b00000101, 0b00000101 ; 0, 48
.db 0b00001000, 0b00000001, 0b00000001, 0b00000000 ; 1
.db 0b00000001, 0b00000001, 0b00001110, 0b00000001 ; 2
.db 0b00000001, 0b00000001, 0b00001011, 0b00000001 ; 3
.db 0b00000000, 0b00000101, 0b00001011, 0b00000000 ; 4
.db 0b00000001, 0b00000100, 0b00001011, 0b00000001 ; 5
.db 0b00000001, 0b00000100, 0b00001111, 0b00000001 ; 6
.db 0b00000001, 0b00000001, 0b00000001, 0b00000000 ; 7
.db 0b00000001, 0b00000101, 0b00001111, 0b00000001 ; 8
.db 0b00000001, 0b00000101, 0b00001011, 0b00000000 ; 9, 57

.db 0b00000001, 0b00000000, 0b00000000, 0b00000001 ; :
.db 0b00000001, 0b00000000, 0b00000000, 0b00000010 ; ;
.db 0b00001000, 0b00000000, 0b00000000, 0b00001000 ; <
.db 0b00000001, 0b00000000, 0b00000000, 0b00000001 ; =
.db 0b00000000, 0b00000010, 0b00000000, 0b00000100 ; >
.db 0b00000001, 0b00000001, 0b00001110, 0b00000001 ; ?
.db 0b00000001, 0b00001101, 0b00001101, 0b00000001 ; @

.db 0b00000001, 0b00000101, 0b00001111, 0b00000000 ; A, 65
.db 0b00000001, 0b00001001, 0b00001001, 0b00000011 ; B
.db 0b00000001, 0b00000100, 0b00000100, 0b00000001 ; C
.db 0b00000001, 0b00000101, 0b00000101, 0b00000001 ; D
.db 0b00000001, 0b00000100, 0b00001110, 0b00000001 ; E
.db 0b00000001, 0b00000100, 0b00001110, 0b00000000 ; F
.db 0b00000001, 0b00000100, 0b00001101, 0b00000001 ; G
.db 0b00000000, 0b00000101, 0b00001111, 0b00000000 ; H
.db 0b00000000, 0b00001000, 0b00000100, 0b00000010 ; I
.db 0b00000000, 0b00000001, 0b00000101, 0b00000001 ; J
.db 0b00001000, 0b00000100, 0b00000110, 0b00001000 ; K
.db 0b00000000, 0b00000100, 0b00000100, 0b00000001 ; L
.db 0b00001000, 0b00000111, 0b00000101, 0b00000000 ; M
.db 0b00000000, 0b00000111, 0b00000101, 0b00001000 ; N
.db 0b00000001, 0b00000101, 0b00000101, 0b00000001 ; O
.db 0b00000001, 0b00000101, 0b00001110, 0b00000000 ; P
.db 0b00000001, 0b00000101, 0b00000101, 0b00001001 ; Q
.db 0b00000001, 0b00000101, 0b00001110, 0b00001000 ; R
.db 0b00000001, 0b00000100, 0b00001011, 0b00000001 ; S
.db 0b00000001, 0b00001000, 0b00000000, 0b00000010 ; T
.db 0b00000000, 0b00000101, 0b00000101, 0b00000001 ; U
.db 0b00000000, 0b00000101, 0b00001010, 0b00000010 ; V
.db 0b00000000, 0b00001101, 0b00000101, 0b00000011 ; W
.db 0b00001000, 0b00000010, 0b00000000, 0b00001100 ; X
.db 0b00001000, 0b00000010, 0b00000000, 0b00000010 ; Y
.db 0b00001001, 0b00000000, 0b00000000, 0b00000101 ; Z, 90

.db 0b00000000, 0b00000000, 0b00000000, 0b00000000 ; space

